// A simple program that computes the square root of a number
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "TutorialConfig.h"
#ifdef USE_MYMATH
#include "MathFunctions.h"
#endif
#if defined HAVE_STRCMPI
#define strcasecmp strcmpi
#elif defined HAVE_STRCASECMP
#define strcmpi strcasecmp
#endif

int main (int argc, char *argv[])
{
  if (argc < 2)
    {
    fprintf(stdout,"%s Version %d.%d\n",
            argv[0],
            Tutorial_VERSION_MAJOR,
            Tutorial_VERSION_MINOR);
    fprintf(stdout,"Usage: %s number\n",argv[0]);
    return 1;
    }
  double inputValue = atof(argv[1]);
#ifdef USE_MYMATH
  puts ("Using mysqrt ()\n");
  double outputValue = mysqrt(inputValue);
#else
  puts ("Using system sqrt ()\n");
  double outputValue = sqrt(inputValue);
#endif
  fprintf(stdout,"The square root of %g is %g\n",
          inputValue, outputValue);

  if (strcmpi ("string1", "string2"))
    {
      puts ("string1 != string2\n");
    }
  else
    {
      puts ("string1 == string2\n");
    }

  return 0;
}
