//~ kolan@nickolay-842 ~/dev/c/zalloc(default) $ time ./zalloc_test 50000 100000
//~ Success, iterations = 50000, nobj = 100000
//~
//~ real	0m0.246s
//~ user	0m0.110s
//~ sys	0m0.130s

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "zalloc.h"
#include "zalloc_ext.h"

int main(int argc, char *argv[])
{
	if (argc != 3) {
		fputs("Usage: realloc_speed_test_cpp iterations nobj\n", stderr);
		exit(-1);
	}

	size_t iterations = (size_t)atoi(argv[1]);
	size_t nobj = (size_t)atoi(argv[2]);

	void **p = zmalloc(sizeof(void *) * nobj);
	memset(p, 0, sizeof(void *) * nobj);

	size_t i, idx, sz;
	for (i = 0; i < iterations; i++) {
		idx = (size_t)(rand() % (int)nobj);
		sz = i;
		p[idx] = zrealloc(p[idx], sz);//zrealloc_inplace(&p[idx], sz);

		if (sz && !p[idx]) {
			fprintf(stderr, "Alloc error at i = %lu\n", i);
			exit(-1);
		}
	}

	for (i = 0; i < nobj; i++)
		zclear(&p[i]);

	zclear(&p);

	printf("Success, iterations = %lu, nobj = %lu\n", iterations, nobj);

	return EXIT_SUCCESS;
}
